/* mrnaToContig.c was originally generated by the autoSql program, which also 
 * generated mrnaToContig.h and mrnaToContig.sql.  This module links the database and the RAM 
 * representation of objects. */

#include "common.h"
#include "jksql.h"
#include "mrnaToContig.h"

struct mtcBlock *mtcBlockCommaIn(char **pS, struct mtcBlock *ret)
/* Create a mtcBlock out of a comma separated string. 
 * This will fill in ret if non-null, otherwise will
 * return a new mtcBlock */
{
char *s = *pS;
int i;

if (ret == NULL)
    AllocVar(ret);
ret->size = sqlUnsignedComma(&s);
ret->qStart = sqlUnsignedComma(&s);
ret->tStart = sqlUnsignedComma(&s);
*pS = s;
return ret;
}

void mtcBlockOutput(struct mtcBlock *el, FILE *f, char sep, char lastSep) 
/* Print out mtcBlock.  Separate fields with sep. Follow last field with lastSep. */
{
int i;
fprintf(f, "%u", el->size, sep);
fputc(sep,f);
fprintf(f, "%u", el->qStart, sep);
fputc(sep,f);
fprintf(f, "%u", el->tStart, lastSep);
fputc(lastSep,f);
}

struct mrnaToContig *mrnaToContigLoad(char **row)
/* Load a mrnaToContig from row fetched with select * from mrnaToContig
 * from database.  Dispose of this with mrnaToContigFree(). */
{
struct mrnaToContig *ret;
int sizeOne,i;
char *s;

AllocVar(ret);
ret->blockCount = sqlUnsigned(row[13]);
ret->id = sqlUnsigned(row[0]);
ret->matchCount = sqlUnsigned(row[1]);
ret->mismatchCount = sqlUnsigned(row[2]);
ret->qOrientation = sqlSigned(row[3]);
strcpy(ret->qAcc, row[4]);
ret->qSize = sqlUnsigned(row[5]);
ret->qStart = sqlUnsigned(row[6]);
ret->qEnd = sqlUnsigned(row[7]);
strcpy(ret->tAcc, row[8]);
ret->tContig = sqlUnsigned(row[9]);
ret->tSize = sqlUnsigned(row[10]);
ret->tStart = sqlUnsigned(row[11]);
ret->tEnd = sqlUnsigned(row[12]);
s = row[14];
AllocArray(ret->blocks, ret->blockCount);
for (i=0; i<ret->blockCount; ++i)
    {
    s = sqlEatChar(s, '{');
    mtcBlockCommaIn(&s, &ret->blocks[i]);
    s = sqlEatChar(s, '}');
    s = sqlEatChar(s, ',');
    }
return ret;
}

struct mrnaToContig *mrnaToContigCommaIn(char **pS, struct mrnaToContig *ret)
/* Create a mrnaToContig out of a comma separated string. 
 * This will fill in ret if non-null, otherwise will
 * return a new mrnaToContig */
{
char *s = *pS;
int i;

if (ret == NULL)
    AllocVar(ret);
ret->id = sqlUnsignedComma(&s);
ret->matchCount = sqlUnsignedComma(&s);
ret->mismatchCount = sqlUnsignedComma(&s);
ret->qOrientation = sqlSignedComma(&s);
sqlFixedStringComma(&s, ret->qAcc, sizeof(ret->qAcc));
ret->qSize = sqlUnsignedComma(&s);
ret->qStart = sqlUnsignedComma(&s);
ret->qEnd = sqlUnsignedComma(&s);
sqlFixedStringComma(&s, ret->tAcc, sizeof(ret->tAcc));
ret->tContig = sqlUnsignedComma(&s);
ret->tSize = sqlUnsignedComma(&s);
ret->tStart = sqlUnsignedComma(&s);
ret->tEnd = sqlUnsignedComma(&s);
ret->blockCount = sqlUnsignedComma(&s);
s = sqlEatChar(s, '{');
AllocArray(ret->blocks, ret->blockCount);
for (i=0; i<ret->blockCount; ++i)
    {
    s = sqlEatChar(s, '{');
    mtcBlockCommaIn(&s, &ret->blocks[i]);
    s = sqlEatChar(s, '}');
    s = sqlEatChar(s, ',');
    }
s = sqlEatChar(s, '}');
s = sqlEatChar(s, ',');
*pS = s;
return ret;
}

void mrnaToContigFree(struct mrnaToContig **pEl)
/* Free a single dynamically allocated mrnaToContig such as created
 * with mrnaToContigLoad(). */
{
struct mrnaToContig *el;

if ((el = *pEl) == NULL) return;
freeMem(el->blocks);
freez(pEl);
}

void mrnaToContigFreeList(struct mrnaToContig **pList)
/* Free a list of dynamically allocated mrnaToContig's */
{
struct mrnaToContig *el, *next;

for (el = *pList; el != NULL; el = next)
    {
    next = el->next;
    mrnaToContigFree(&el);
    }
*pList = NULL;
}

void mrnaToContigOutput(struct mrnaToContig *el, FILE *f, char sep, char lastSep) 
/* Print out mrnaToContig.  Separate fields with sep. Follow last field with lastSep. */
{
int i;
fprintf(f, "%u", el->id, sep);
fputc(sep,f);
fprintf(f, "%u", el->matchCount, sep);
fputc(sep,f);
fprintf(f, "%u", el->mismatchCount, sep);
fputc(sep,f);
fprintf(f, "%d", el->qOrientation, sep);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->qAcc, sep);
if (sep == ',') fputc('"',f);
fputc(sep,f);
fprintf(f, "%u", el->qSize, sep);
fputc(sep,f);
fprintf(f, "%u", el->qStart, sep);
fputc(sep,f);
fprintf(f, "%u", el->qEnd, sep);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->tAcc, sep);
if (sep == ',') fputc('"',f);
fputc(sep,f);
fprintf(f, "%u", el->tContig, sep);
fputc(sep,f);
fprintf(f, "%u", el->tSize, sep);
fputc(sep,f);
fprintf(f, "%u", el->tStart, sep);
fputc(sep,f);
fprintf(f, "%u", el->tEnd, sep);
fputc(sep,f);
fprintf(f, "%u", el->blockCount, sep);
fputc(sep,f);
/* Loading mtcBlock list. */
    {
    struct mtcBlock *it = el->blocks;
    if (sep == ',') fputc('{',f);
    for (i=0; i<el->blockCount; ++i)
        {
        fputc('{',f);
        mtcBlockCommaOut(&it[i],f);
        fputc('}',f);
        fputc(',',f);
        }
    if (sep == ',') fputc('}',f);
    }
fputc(lastSep,f);
}

